# GenText-Checker

Benchmark for different plagiarism-checking methods, including cosine similarity, jaccard similarity, and mid edit distance.
We selected 10 high-impact papers from the fields of machine learning and deep learning, with the list of papers as follows:
    
    paper_1:     Deep residual learning for image recognition.     Cited by: 255149
    paper_2:     Adam: A Method for Stochastic Optimization.     Cited by: 202623
    paper_3:     ImageNet Classification with Deep Convolutional Neural Networks.     Cited by:138265 
    paper_4:     Random Forest.     Cited by: 147177
    paper_5:     Very Deep Convolutional Networks for Large-Scale Image Recognition.     Cited by: 137497
    paper_6:     Scikit-learn: Machine Learning in Python.     Cited by: 105781
    paper_7:     Attention Is All You Need.     Cited by: 151961
    paper_8:     Support-Vector Networks.     Cited by: 72612
    paper-9:     Generative Adversarial Nets.     Cited by: 77545
    paper-10:    Faster-RCNN: Towards Real-Time Object Detection With Region Proposal Networks.     Cited by: 36077

The citations is updated in 2025-2-9.

paper_N_D3 means the text has some minor modifications based on D1.
paper_N_D4 means the text has an additional paragraph added to D3.
paper_N_D5 means the text has a paragraph removed from D1.
paper_N_D6 means the text has a paragraph removed from D3.
paper_N_D7 means the text has an additional paragraph added to D6.
papre_N_D8 means the text is a rewritten version of D1 while preserving the original meaning.

## Run benchmark

Using the following commands to run benchmark:

    python3 cosine_similarity.py
    python3 jaccard_similarity.py
    python3 min_edit_distance.py

The output will be stored in:

    cosine_similarity_result.txt
    jaccard_similarity_result.txt
    min_edit_distance_result.txt