import os

def splitWords(text):
    res_words = list()

    # Loop through each line of the file 
    for line in text: 
        # Remove the leading spaces and newline character 
        line = line.strip() 
  
        # Convert the characters in line to 
        # lowercase to avoid case mismatch 
        line = line.lower() 
  
        # Split the line into words 
        sentences = line.split(".")

        for sentence in sentences:
            if len(sentence) == 0:
                continue

            words = sentence.split(" ")

            # Iterate over each word in line 
            for word in words:
                if word == ',' or word == '':
                    continue

                res_words.append(word)

    return res_words

def addWordtoSet(text):
    words_set = set()

    words = splitWords(text)
    for word in words:
        words_set.add(word)

    return words_set

def intersection(set_a, set_b):
    set_c = set_a.intersection(set_b)
    return set_c

def union(set_a, set_b):
    set_c = set_a.union(set_b)
    return set_c

if __name__ == "__main__":

    output = open("jaccard_similarity_result.txt", "w")

    # Open the file in read mode 
    for i in range(1, 11):
        for j in range(3, 9):
              file_a = "./data/paper_"+str(i)+".txt"
              file_b = "./data/paper_"+str(i)+"_D"+str(j)+".txt"

              # Open the file in read mode 
              text_a = open(file_a, "r") 
              text_b = open(file_b, "r")

              # Construct word set
              words_set_a = addWordtoSet(text_a)
              words_set_b = addWordtoSet(text_b)

              print("Length of word set a: ", len(words_set_a))
              print(words_set_a)
              print("Length of word set b: ", len(words_set_b))
              print(words_set_b)

              intersection_a_b = intersection(words_set_a, words_set_b)

              print("Intersection of two sets:")
              print(intersection_a_b)

              union_a_b = union(words_set_a, words_set_b)

              print("Union of two sets:")
              print(union_a_b)

              # compute jaccard similarity
              jaccard_similarity = len(intersection_a_b) / len(union_a_b)

              out_str = "Jaccard Similarity: " + file_a + " " + file_b + " " + str(jaccard_similarity) + "\n"
              output.write(out_str)