import math

def min_edit_distance(a, b):
        dp = [[0 for i in range(len(b) + 1)] for j in range(len(a) + 1)]
        for i in range(len(a) + 1):
            dp[i][0] = i
        for j in range(len(b) + 1):
            dp[0][j] = j
        for i in range(1, len(a) + 1):
            for j in range(1, len(b) + 1):
                if a[i - 1] == b[j - 1]:
                    dp[i][j] = dp[i - 1][j - 1]
                else:
                    dp[i][j] = min(dp[i - 1][j] + 1, dp[i][j - 1] + 1, dp[i - 1][j - 1] + 1)
        # print(dp[-1][-1])
        return dp[-1][-1]


if __name__ == "__main__":

    output = open("mid_edit_distance_result.txt", "w")

    for i in range(1, 11):
        for j in range(3, 9):
            file_a = "./data/paper_"+str(i)+".txt"
            file_b = "./data/paper_"+str(i)+"_D"+str(j)+".txt"

            with open(file_a, 'r') as file:
                A = file.read()

            with open(file_b, 'r') as file:
                B = file.read() 

            print(A)

            print("-----")

            print(B)

            print("Distance:")
            distance = min_edit_distance(A,B)
            print(distance)

            print("A length:")
            print(len(A))

            print("B length:")
            print(len(B))

            print("abs(A-B):")
            abs_ab = abs(len(A)-len(B))
            print(abs_ab)

            print("eta:")
            eta = distance-abs_ab
            print(eta)

            print("Plag:")

            p = 1 - (eta / len(A))

            #if len(B) > len(A):
            #    p = 1.0 - (distance / len(B))
            #else:
            #    p = 1.0 - (distance / len(A))

            out_str = "Min edit distance: " + file_a + " " + file_b + " " + str(p) + "\n"
            output.write(out_str)
